Library IEEE;
USE IEEE.std_logic_1164.all;
USE IEEE.std_logic_unsigned.all;

entity Aux_DAC_Mux_v4 is 
	port( 	
			DAC_Sel	: in std_logic_vector(2 downto 0);

			Data_0		: in std_logic_vector(15 downto 0);
			Data_0_strb	: in std_logic;
			
			Data_1		: in std_logic_vector(15 downto 0);
			Data_1_strb	: in std_logic;
			
			Data_2		: in std_logic_vector(15 downto 0);
			Data_2_strb	: in std_logic;
			
			Data_3		: in std_logic_vector(15 downto 0);
			Data_3_strb	: in std_logic;
			
			Data_4		: in std_logic_vector(15 downto 0);
			Data_4_strb	: in std_logic;
			
			Data_5		: in std_logic_vector(15 downto 0);
			Data_5_strb	: in std_logic;
			
			Data_6		: in std_logic_vector(15 downto 0);
			Data_6_strb	: in std_logic;
			
			Data_7		: in std_logic_vector(15 downto 0);
			Data_7_strb	: in std_logic;
			
			
			DAC_Data_out	: out std_logic_vector(15 downto 0);
			DAC_Data_strb	: out std_logic
			      		      
		);
	end Aux_DAC_Mux_v4;
	
architecture main of Aux_DAC_Mux_v4 is	
             
signal sel		: std_logic_vector(2 downto 0);

           
begin
	sel <= DAC_Sel;
	
	INTERFACE_SIGNAL_MUX:
	process(sel, Data_0, Data_0_strb, Data_1, Data_1_strb, Data_2, Data_2_strb, 
	        Data_3, Data_3_strb, Data_4, Data_4_strb, Data_5, Data_5_strb, 
	        Data_6, Data_6_strb, Data_7, Data_7_strb)
	begin
			    
		case sel is
			when "000" =>  
				DAC_Data_out 	<= Data_0;	
				DAC_Data_strb	<= Data_0_strb;	
			when "001" =>               
				DAC_Data_out 	<= Data_1;	
				DAC_Data_strb	<= Data_1_strb;	
			when "010" =>               
				DAC_Data_out 	<= Data_2;	
				DAC_Data_strb	<= Data_2_strb;	
			when "011" =>               
				DAC_Data_out 	<= Data_3;	
				DAC_Data_strb	<= Data_3_strb;	
			when "100" =>               
				DAC_Data_out 	<= Data_4;	
				DAC_Data_strb	<= Data_4_strb;	
			when "101" =>               
				DAC_Data_out 	<= Data_5;	
				DAC_Data_strb	<= Data_5_strb;	
			when "110" =>               
				DAC_Data_out 	<= Data_6;	
				DAC_Data_strb	<= Data_6_strb;	
			when "111" =>              
				DAC_Data_out 	<= Data_7;	
				DAC_Data_strb	<= Data_7_strb;	
			when others =>             
				DAC_Data_out 	<= Data_0;	
				DAC_Data_strb	<= Data_0_strb;	
			    
			end case;	
	
	end process;

end;